<script>
  import Title from "../lib/Title.svelte";
  import Header from "../lib/Header.svelte";
  import Paragraph from "../lib/Paragraph.svelte";
  import List from "../lib/List.svelte";
  import ListItem from "../lib/ListItem.svelte";
  import Image from "../lib/Image.svelte";
  import Important from "../lib/Important.svelte";
  import Youtube from "../lib/Youtube.svelte";

  const codigo = `// Se certifica de mover o motor dentro do limite de 0 a 180 graus
void moveServo(Servo servo, int quantidade)
{
  int anguloAtual = servo.read();
  int anguloFinal = anguloAtual + quantidade;
  if (anguloFinal <= 180 && anguloFinal >= 0)
  {
    servo.write(anguloFinal);
  }
}`;

  const codigoFinal = `//Verifica o eixo Y
if (leste < oeste)
{
  moveServo(EixoY, 1);
}
else if (oeste < leste)
{
  moveServo(EixoY, -1);
}

//Verifica o eixo X
if (norte < sul)
{
  moveServo(EixoX, MoveEixoX);
}
else if (sul < norte)
{
  moveServo(EixoX, -MoveEixoX);
}`;
</script>

<svelte:head>
  <title>Seguidor Solar</title>
  <meta
    name="description"
    content="Projeto com arduino da disciplina Introdução a Engenharia de Computação, com o objetivo de construir um seguidor solar pequeno e de baixo custo, que possui sensores LDR para identificar a luz solar e servo motores para posicionar os painéis"
  />
</svelte:head>

<Title>Seguidor Solar</Title>
<Image src="tracker.jpg" alt="painel solar" />

<Header>Índice</Header>
<List listType="ul">
  <ListItem><a href="#introdução">Introdução</a></ListItem>
  <ListItem><a href="#objetivos">Objetivos</a></ListItem>
  <ListItem><a href="#materiais-utilizados">Materiais Utilizados</a></ListItem>
  <ListItem><a href="#diagrama-eletrico">Diagramas elétrico</a></ListItem>
  <ListItem><a href="#montagem">Montagem</a></ListItem>
  <ListItem><a href="#codigo">O algoritimo</a></ListItem>
  <ListItem><a href="#resultados">Resultados</a></ListItem>
  <ListItem><a href="#desafios-encontrados">Desafios encontrados</a></ListItem>
  <ListItem><a href="#conclusao">Conclusão</a></ListItem>
  <ListItem><a href="#referencias">Referencias</a></ListItem>
</List>

<section id="introdução">
  <Header>Introdução</Header>
  <Paragraph
    >Muitos dos melhores designs que vemos da atualidade são inspirados na
    natureza, essa por sua vez que tem muito a nos ensinar com seus milhões de
    anos de experiência, foi observando ela (e alguns vídeos no youtube) que
    surgiu essa ideia, um painel solar que segue a luz do sol, idêntico a um
    girassol. O ponto é que para o painel solar produzir energia ele se utiliza
    de célula fotovoltaica (dispositivo que convierte a luz proveniente do Sol
    diretamente em energia elétrica) e essas células perdem sua eficiência
    quando os raios solares as atingem em ângulo, então o objetivo do projeto é
    ter um melhor aproveitamento de energia solar. Para isso iremos utilizar
    sensores LDR(resistor que varia sua resistência conforme a intensidade de
    luz que incide sobre ele) para definir a posição do sol, e motores
    servo(motores que possuem rotação controlada de 0 a 180 graus) para mover os
    painéis na direção dele.
  </Paragraph>
</section>

<section id="objetivos">
  <Header>Objetivos</Header>
  <Paragraph>
    Construir um seguidor solar pequeno e de baixo custo, que possui como
    objetivo identificar e seguir a luz do sol através dos sensores LDR, quando
    os sensores identificam onde está a fonte de luz mais brilhante, os
    servomotores executam os movimentos, para posicionar os painéis nessa mesma
    direção, deste modo aumentando a captação de energia solar.
  </Paragraph>
</section>

<section id="materiais-utilizados">
  <Header>Materiais Utilizados</Header>

  <List listType="ul">
    <ListItem
      >Arduino UNO (ou qualquer arduino com capacidade similar);</ListItem
    >
    <ListItem>2 servos motores;</ListItem>
    <ListItem>4 sensores de luz (LDR);</ListItem>
    <ListItem>1 Painel solar (ou mais);</ListItem>
    <ListItem>1 L7805C regulador de tensão 5V;</ListItem>
    <ListItem>1 Capacitor electrolítico 1000uF x 50V;</ListItem>
    <ListItem>1 Capacitor Ceramico 100nF x 50V;</ListItem>
    <ListItem>1 Conector USB fêmea;</ListItem>
    <ListItem>4 resistores de 10kΩ;</ListItem>
    <ListItem>1 chave gangorra;</ListItem>
    <ListItem>Fios para conexão;</ListItem>
    <ListItem
      >Materiais para construção de uma base(como cola quente, madeira,
      plástico, etc);</ListItem
    >
  </List>
</section>

<section id="diagrama-eletrico">
  <Header>Diagramas elétricos</Header>
  <Image
    src="LigacaoArduino.png"
    alt="Diagrama de ligação da placa do arduino"
  />
  <Image src="LigacaoSolar.png" alt="Diagrama de ligação dos paineis solares" />
  <Image src="LigacaoGeral.png" alt="Diagrama de ligação geral" />

  <Paragraph />
</section>

<section id="montagem">
  <Header>Montagem</Header>
  <Important
    >Antes um esclarecimento os materiais exatos da estrutura do projeto não
    foram especificados, pois podem ser substituídos por qualquer material que
    possua uma certa rigidez, fácil de se trabalhar e que você possua a seu
    alcance(como mdf, plastico, isopor rígido etc).</Important
  >

  <Paragraph
    >Para a montagem os motores servos devem ficar com o eixo na posição de 90º,
    o primeiro motor servo que chamaremos de S1 fica na base deitado com seu
    eixo virado para cima, o segundo moto S2 fica logo sobre o eixo do S1
    prendido por uma base com seu eixo curvado para dentro e por último temos o
    suporte do painel solar, que deve ser instalado no eixo do S2 fazendo com
    que o painel fique perpendicular ao céu, sempre que os motores estiverem na
    posição de 90º o painel deve estar perpendicular ao céu, o motivo será
    explicado junto ao algoritmo.</Paragraph
  >
  <Image src="Base.svg" alt="demonstração do projeto montado" />
  <Paragraph
    >Os sensores LDR devem ser montados em uma base circular de aproximadamente
    6 cm, um em cada canto separados por quatro paredes que servem para impedir
    a entrada de luz solar pelo que não for a sua direção de atuação, a altura
    da parede deve ser de aproximadamente de 3 cm, por fim a base circular deve
    ser montada em uma das beiradas do painel solar, o quanto mais centralizado
    possível para melhorar a acurácia dos sensores.</Paragraph
  >
  <Image src="Sensores.svg" alt="demonstração da posição dos sensores" />
  <Paragraph
    >O arduino e restante de componentes podem ser armazenados na base do
    projeto, e as ligações devem ser feitas conforme os diagramas elétricos
    acima.
  </Paragraph>
</section>

<section id="codigo">
  <Header>O algoritimo</Header>
  <Paragraph
    >Como se trata de um dispositivo que possui movimentação em dois eixos, o
    algoritmo requer muitos pensamentos abstratos em 3 dimensões, então para
    facilitar a comunicação e alinhar o seus pensamentos com os nossos, nós
    vamos adotar daqui em diante a rosa dos ventos como ponto de referência.
    Agora vamos chamar o eixo de rotação do S1 de eixo X e o eixo do S2 de eixo
    Y e também consideramos que os motores servos possuem uma rotação de 0º a
    180º no sentido anti-horário.
  </Paragraph>
  <Paragraph
    >Agora imagine que você está virado em direção ao nascer do sol(leste), com
    eixo X a 90º e o eixo Y a 180º o painel solar deve estar apontando para
    frente, e agora se movermos apenas o eixo Y para 0º, o painel solar deve
    estar apontando para o pôr do sol(oeste), assim percebemos que a função do
    eixo Y é seguir o sol durante o dia, e a função do eixo X é acompanhar as
    diferentes posições do sol durante as estações(norte e sul).</Paragraph
  >
  <Image
    src="explicacao.svg"
    alt="apresenta um desenho para facilitar a explicação do algoritimo"
  />
  <Important>
    Perceba também que quando a posição do eixo Y for menor que 90º se inverte a
    posição do eixo X, pois ele estará do lado contrário a rotação do eixo X.</Important
  >
  <pre>//Dependendo da direção do motor Y em a movimentação do motor X e invertida
int MoveEixoX = EixoY.read() &lt 90 ? -1 : 1;
  </pre>
  <Paragraph
    >Para controlar os servos motores nós usamos uma biblioteca chamada <code
      >Servo.h</code
    >, para usar essa biblioteca primeiro você tem que declarar as variáveis do
    motor e em seguida no <code>setup()</code> você deve iniciar os motores.</Paragraph
  >
  <pre>
//Base
Servo EixoX;
//Angulo do painel
Servo EixoY;
    
// Setup
//Iniciando os servos motores
  EixoX.attach(8);
  EixoY.attach(9);
    </pre>
  <Paragraph
    >Para definir uma posição deve ser usar <code> motor.write(angulo)</code> e
    para ler a atual posição do motor <code>motor.read()</code></Paragraph
  >
  <pre>
{codigo}
  </pre>

  <Paragraph
    >Os sensores LDR diminuem sua resistência conforme aumenta a incidência de
    luz solar sobre eles, sendo assim possível calcular a diferença de luz sobre
    um sensor e outro, eles estarão posicionados nos pontos colaterais(noroeste,
    sudoeste, sudeste, nordeste) da rosa dos ventos, assim a soma de dois
    sensores do mesmo lado nos dá um dos pontos cardeais, e usando essa essa
    informação podemos prever para qual direção devemos mover os servos motores.</Paragraph
  >
  <pre>
//Definindo o nome dos pinos
    
// Noroeste
#define NO A0
// Sudoeste
#define SO A1
// Sudeste
#define SE A2
// Norderste
#define NE A3

//Loop()
int leste = sudeste + nordeste;
int sul = sudoeste + sudeste;
int oeste = noroeste + sudoeste;
int norte = noroeste + nordeste;

  {codigoFinal}
</pre>
  <Important
    >O código final pode ser baixado direto do <a
      target="_blank"
      rel="noopener"
      href="https://gitlab.com/diovani.eduardo.coelli/ie21cp20202/-/tree/master/src"
      >repositório do gitlab</a
    >
    ele está na pasta src, note que nesse projeto foi desenvolvido utilizando PlatformIO,
    e no início do arquivo a um
    <code>#include &lt;Arduino.h&gt;</code>
    que deve ser removido caso você esteja utilizando a IDE do arduino, outra alternativa
    seria ver o código direto no projeto do
    <a
      target="_blank"
      rel="noopener"
      href="https://www.tinkercad.com/things/c2TI6noWZLC">tinkercad</a
    >.
  </Important>
</section>

<section id="resultados">
  <Header>Resultados</Header>
  <Paragraph
    >Não foi possível montar o projeto fisicamente, então não foi possível
    averiguar seus resultado, porém segundo pesquisas se espera um aumento de
    35% a 40% na captação de energia solar.</Paragraph
  >
  <Youtube />
</section>

<section id="desafios-encontrados">
  <Header>Desafios encontrados</Header>
  <Paragraph
    >A principal desvantagem que nó podemos pensar é que se houver sombra sobre
    um sensor ele pode ficar perdido, para isso deve se montar a unidade onde
    nenhum objeto possa fazer sombra sobre o sensor , outro é que os motores e o
    arduino consomem parte da energia produzida diminuindo a eficiência para
    isso seria necessário utilizar de motores e placas mais eficientes, e por
    último tem o custo em relação a um simples painel solar, que devido aos
    eletrônicos aumenta consideravelmente.
  </Paragraph>
</section>

<section id="conclusao">
  <Header>Conclusão</Header>
  <Paragraph
    >Foi um projeto muito divertido e desafiador de se fazer apesar de que não
    foi possível construir uma unidade física, a parte mais proveitosa foi
    conseguir quebrar pensamentos complexos em pedaços menores(usando a rosa dos
    ventos para montar e explicar o algoritmo) e de mais fácil entendimento e
    também perceber problemas no design e no algoritmo conforme fomos escrevendo
    a documentação. Mesmo se tratando de um projeto inicial, futuramente, o
    mesmo pode ser aprimorado e aplicado em ambientes externos. Através deste
    projeto foi possível ter uma ideia de como funciona o arduino na prática e
    consequentemente desenvolver soluções e aprimoramentos para problemas, que
    existem hoje, na atual sociedade.
  </Paragraph>
</section>

<section id="referencias">
  <Header>Referencias</Header>
  <List listType="ul">
    <ListItem>
      <a
        target="_blank"
        rel="noopener"
        href="https://gitlab.com/diovani.eduardo.coelli/ie21cp20202/"
        >Repositório no Gitlab</a
      >
    </ListItem>
    <ListItem>
      <a
        target="_blank"
        rel="noopener"
        href="https://www.tinkercad.com/things/c2TI6noWZLC"
        >Projeto no Tinkercad</a
      >
    </ListItem>
    <ListItem>
      <a
        target="_blank"
        rel="noopener"
        href="https://www.portalsolar.com.br/o-que-e-energia-solar-.html"
        >Portal solar. O que é energia solar?</a
      >
    </ListItem>

    <ListItem>
      <a
        target="_blank"
        rel="noopener"
        href="https://www.youtube.com/watch?v=zc-N13YEqlk&t=469s"
        >Faça em casa um carregador de celular solar Manual do Mundo</a
      >
    </ListItem>
    <ListItem
      ><a
        target="_blank"
        rel="noopener"
        href="https://roboticmente.blogspot.com/2019/02/energia-solar-com-arduino.html"
        >ENERGIA SOLAR COM ARDUÍNO</a
      >
    </ListItem>
  </List>
</section>
